<script>
    import { getDateTimeTickInfo } from "./datetimetickinfo.js";
    import * as d3 from "d3";

    export let subplot;
    export let xScale;

    let tickSizePrimary = 4;
    let tickSizeSecondary = 30;
    let showSecondaryTickMark = true;

    $: tickInfo = getDateTimeTickInfo(xScale);

    $: bottom = subplot.computed.y + subplot.computed.h;
    $: top = subplot.computed.y;
    $: left = xScale.range()[0];
    $: right = xScale.range()[1];

    // Set formatting options based on whether the ticks are for
    //   time instances or intervals
    let textAnchor;
    let textOffsetX;
    let tickOffsetY;
    $: {
        if (tickInfo.tickformat_p.startsWith("%H:%M")) {
            textAnchor = "middle";
            textOffsetX = 0;
            tickOffsetY = 20;
        } else {
            textAnchor = "begin";
            textOffsetX = 12;
            tickOffsetY = 0;
        }
    }

    // Primary x-axis ticks
    $: primaryTicks = xScale.ticks(tickInfo.interval_p);
    $: secondaryTicks = xScale.ticks(tickInfo.interval_s);
    $: primaryFormatter = d3.utcFormat(tickInfo.tickformat_p);
    $: secondaryFormatter = d3.utcFormat(tickInfo.tickformat_s);

    // If there are no default secondary ticks (too far zoomed in on a day or month), show annotation at the left without a tick mark, for context
    $: {
        if (secondaryTicks.length == 0) {
            secondaryTicks = [xScale.domain()[0]];
            showSecondaryTickMark = false;
        } else {
            showSecondaryTickMark = true;
        }
    }

    // Day ticks
    let dayTicks = [];
    $: {
        if (
            tickInfo.tickformat_p.startsWith("%d") ||
            tickInfo.tickformat_p.startsWith("%H")
        ) {
            dayTicks = xScale.ticks(d3.utcDay);
        } else {
            dayTicks = [];
        }
    }
</script>

<!-- Add the day vertical bars -->

<g class="dayticks">
    {#each dayTicks as tick}
        <line
            x1={xScale(tick)}
            x2={xScale(tick)}
            y1={subplot.computed.y}
            y2={subplot.computed.y + subplot.computed.h}
            class="stroke-black dark:stroke-white"
            stroke-opacity="15%" />
    {/each}
</g>

<g class="xaxis">
    <!-- Horizontal axis line, spanning the full domain -->
    <!-- Bottom -->
    <line
        x1={left}
        x2={right}
        y1={bottom}
        y2={bottom}
        stroke="black"
        class="stroke-black dark:stroke-white"
        stroke-width="1.5" />

    <!-- Top -->
    <!-- <line
        x1={left}
        x2={right}
        y1={top}
        y2={top}
        class="stroke-black dark:stroke-white"
        stroke-width="0.5" /> -->

    <!-- Primary axis ticks -->
    {#if subplot.xaxis_ticks != "hidden"}
        {#each primaryTicks as tick}
            <line
                x1={xScale(tick)}
                x2={xScale(tick)}
                y1={subplot.computed.y + subplot.computed.h}
                y2={subplot.computed.y + subplot.computed.h + tickSizePrimary}
                stroke="black"
                class="stroke-black dark:stroke-white"
                stroke-width="0.75" />
            {#if subplot.xaxis_annotation == "visible" && tickInfo.visibility_annot_p == "visible"}
                <text
                    x={xScale(tick) + textOffsetX}
                    y={subplot.computed.y +
                        subplot.computed.h +
                        tickSizePrimary +
                        12}
                    font-family="-apple-system, 'Helvetica Neue', sans-serif"
                    font-size="12px"
                    fill="black"
                    class="fill-black dark:fill-white"
                    text-anchor={textAnchor}>{primaryFormatter(tick)}</text>
            {/if}
        {/each}

        <!-- Secondary axis ticks -->
        {#each secondaryTicks as tick}
            {#if subplot.xaxis_annotation == "visible"}
                {#if showSecondaryTickMark}
                    <line
                        x1={xScale(tick)}
                        x2={xScale(tick)}
                        y1={subplot.computed.y +
                            subplot.computed.h +
                            tickOffsetY}
                        y2={subplot.computed.y +
                            subplot.computed.h +
                            tickSizeSecondary}
                        stroke="black"
                        class="stroke-black dark:stroke-white"
                        stroke-width="0.75" />
                {/if}
                <text
                    x={xScale(tick) + 8}
                    y={subplot.computed.y +
                        subplot.computed.h +
                        tickSizePrimary +
                        24}
                    font-family="-apple-system, 'Helvetica Neue', sans-serif"
                    font-size="12px"
                    fill="black"
                    class="fill-black dark:fill-white"
                    text-anchor="begin">
                    {secondaryFormatter(tick)}
                </text>
            {:else if showSecondaryTickMark}
                <line
                    x1={xScale(tick)}
                    x2={xScale(tick)}
                    y1={subplot.computed.y + subplot.computed.h}
                    y2={subplot.computed.y +
                        subplot.computed.h +
                        tickSizeSecondary / 2}
                    stroke="black"
                    class="stroke-black dark:stroke-white"
                    stroke-width="0.75" />
            {/if}
        {/each}
    {/if}
</g>

<style>
    text {
        user-select: none;
    }
</style>
